<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="总额度" prop="totalQuota">
        <el-input v-model="formData.totalQuota" placeholder="请输入总额度" />
      </el-form-item>
      <el-form-item label="已消耗" prop="usedQuota">
        <el-input v-model="formData.usedQuota" placeholder="请输入已消耗次数" />
      </el-form-item>
      <el-form-item label="版本号" prop="version">
        <el-input v-model="formData.version" placeholder="请输入版本号" />
      </el-form-item>
      <el-form-item label="创建时间" prop="createdAt">
        <el-date-picker
          v-model="formData.createdAt"
          type="date"
          value-format="x"
          placeholder="选择创建时间"
        />
      </el-form-item>
      <el-form-item label="更新时间" prop="updatedAt">
        <el-date-picker
          v-model="formData.updatedAt"
          type="date"
          value-format="x"
          placeholder="选择更新时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { UserQuotaTotalApi, UserQuotaTotal } from '@/api/keyboard/userquotatotal'

/** 用户免费功能永久总次数额度表（所有功能共用） 表单 */
defineOptions({ name: 'UserQuotaTotalForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  userId: undefined,
  totalQuota: undefined,
  usedQuota: undefined,
  version: undefined,
  createdAt: undefined,
  updatedAt: undefined
})
const formRules = reactive({
  totalQuota: [{ required: true, message: '总额度不能为空', trigger: 'blur' }],
  usedQuota: [{ required: true, message: '已消耗次数不能为空', trigger: 'blur' }],
  version: [{ required: true, message: '版本号不能为空', trigger: 'blur' }],
  createdAt: [{ required: true, message: '创建时间不能为空', trigger: 'blur' }],
  updatedAt: [{ required: true, message: '更新时间不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserQuotaTotalApi.getUserQuotaTotal(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserQuotaTotal
    if (formType.value === 'create') {
      await UserQuotaTotalApi.createUserQuotaTotal(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserQuotaTotalApi.updateUserQuotaTotal(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    userId: undefined,
    totalQuota: undefined,
    usedQuota: undefined,
    version: undefined,
    createdAt: undefined,
    updatedAt: undefined
  }
  formRef.value?.resetFields()
}
</script>
